/**
***     shape.cpp
***
***     Copyright (C) 2008 SophiaCradle Incorporated.
***     All rights reserved.
***
***     ̃\[XR[h̓G[XgbvATXyhȂǂ̏Ă܂B
***     ۂ̎gpɍۂẮAKvɉďǉĂB
***
**/

#include "shape.hpp"

// Aj[V̒lvZ^C}[l
#define ANI_TIMER   100


//
// ̗lԂ܂B
// 0ȏn̗Ԃ܂B
//
SIntN RandInt(SIntN n)
{
    return SFXBrewRandom::GetUInt32() % n;
}


//
//    RXgN^
//
shape::shape()
{
    // VF擾B
    SFBShellSmp shell(SFBShell::GetInstance());

    // `nh̓o^
    if (static_try()) {
        static_throw(RegisterHandler(SFXEventRange(SFEVT_RESPONDER_RENDER, SFEVT_RESPONDER_RENDER, SFP16_BEGIN, SFP16_END), XANDLER_INTERNAL(OnDraw)));
    }

    // ^C}[̐ݒ
    shell->SetTimer(ANI_TIMER, OnTimerEntry, this);

    // ~0̏
    m_c0.SetRadius(4 + RandInt(10));
    m_c0.SetX(20 + RandInt(60));
    m_c0.SetY(20 + RandInt(60));

    // ~1̏
    m_c1.SetRadius(4 + RandInt(10));
    m_c1.SetX(20 + RandInt(60));
    m_c1.SetY(20 + RandInt(60));

    // ~2̏
    m_c2.SetRadius(4 + RandInt(10));
    m_c2.SetX(20 + RandInt(60));
    m_c2.SetY(20 + RandInt(60));
}


//
//    fXgN^
//
shape::~shape()
{
    // Ȃ
}


//
//    `nh
//
XANDLER_IMPLEMENT_VOIDRENDER(shape, OnDraw, invoker, reason, graphics)
{
    unused(invoker);
    unused(reason);
    SFBShellSmp             shell(SFBShell::GetInstance()); // VF̃CX^X擾
    AEEDeviceInfo           info;                           // foCX̏i[̈
    SFXRectangle            disp_rect;                      // ʃTCYi[̈
    SFXRGBColor             bg_color(255, 255, 255, 0);     // wiFݒ
    SFXRGBColor             tri_color(0, 0, 0, 0);          // Op`̐̐F()
    SFXRGBColor             c0_color(255, 0, 0, 0);         // ~C0̐̐F()
    SFXRGBColor             c1_color(0, 255, 0, 0);         // ~C1̐̐F()
    SFXRGBColor             c2_color(0, 0, 255, 0);         // ~C2̐̐F()

    // foCX̏擾
    shell->GetDeviceInfo(&info);

    // ʃTCYݒ肷B
    disp_rect.Set(0, 0, info.cxScreen, info.cyScreen);

    // ʂ̔wiFݒ肷B
    graphics->SetBackColor(bg_color);

    // ʂhԂB
    graphics->ClearRectangle(disp_rect);


    // Op``悷B
    SFXTriangle tri(m_c0.GetOrigin(), m_c1.GetOrigin(), m_c2.GetOrigin());
    graphics->SetForeColor(tri_color);     // ̐Fݒ肷(F)
    graphics->SetFillMode(false);      // Op`́AhԂȂB
    graphics->DrawTriangle(tri);


    // ~́AhԂB
    graphics->SetFillMode(true);

    // ~̓̐Fݒ肷B(C0)
    graphics->SetFillColor(c0_color);

    // ~`悷B(C0)
    graphics->DrawCircle(m_c0);

    // ~̓̐Fݒ肷B(C1)
    graphics->SetFillColor(c1_color);

    // ~`悷B(C1)
    graphics->DrawCircle(m_c1);

    // ~̓̐Fݒ肷B(C2)
    graphics->SetFillColor(c2_color);

    // ~`悷B(C2)
    graphics->DrawCircle(m_c2);
}


//
// ^C}[nh
//
Void shape::OnTimer(Void)
{
    // VF擾B
    SFBShellSmp             shell(SFBShell::GetInstance());

    // ~̔aƍWvZB(C0)
    m_c0.SetRadius(ABS(m_c0.GetRadius() + RandInt(3) - 1));
    m_c0.AddX(RandInt(3) - 1);
    m_c0.AddY(RandInt(3) - 1);

    // ~̔aƍWvZB(C1)
    m_c1.SetRadius(ABS(m_c1.GetRadius() + RandInt(3) - 1));
    m_c1.AddX(RandInt(3) - 1);
    m_c1.AddY(RandInt(3) - 1);

    // ~̔aƍWvZB(C2)
    m_c2.SetRadius(ABS(m_c2.GetRadius() + RandInt(3) - 1));
    m_c2.AddX(RandInt(3) - 1);
    m_c2.AddY(RandInt(3) - 1);

    // ĕ`𑣂B
    SFYApplication::Render(true);

    // ^C}[̍Đݒ
    shell->SetTimer(ANI_TIMER, OnTimerEntry, this);
}
